#include <gcj/cni.h>
#include <com/redhat/tomcat/Daemon.h>
#include <java/lang/AssertionError.h>
#include <java/lang/RuntimeException.h>

#include <unistd.h>
#include <signal.h>

/* See the Javadoc in Daemon.java for details */

extern "C" {
    extern void daemon_init();
    extern void daemon_recreate_log();
    extern void daemon_cleanup();
}

static bool stopping = false;
static jint logserial = 0;

static sighandler_t termhandler = NULL;
static sighandler_t inthandler  = NULL;

static void sighandler(int sig) {
    sighandler_t upstream = NULL;
    switch (sig) {
    case SIGTERM:
	stopping = true;
	upstream = termhandler;
	break;
    case SIGINT:
	stopping = true;
	upstream = inthandler;
	break;
    case SIGUSR1:
	logserial++;
	daemon_recreate_log();
	break;
    }
    if (upstream)
	(*upstream)(sig);
}

static sighandler_t xsignal(int signum, sighandler_t handler)
{
    sighandler_t ret = signal(signum, handler);
    if (ret == SIG_ERR)
	throw new java::lang::RuntimeException(
	    JvNewStringLatin1("signal() failed"));

    return ret;
}

void com::redhat::tomcat::Daemon::daemon()
{
    sighandler_t usr1handler;

    termhandler = xsignal(SIGTERM, sighandler);
    inthandler  = xsignal(SIGINT,  sighandler);
    usr1handler = xsignal(SIGUSR1, sighandler);
    if (usr1handler != NULL)
	throw new java::lang::AssertionError(
	    JvNewStringLatin1("usr1handler != NULL"));

    daemon_init();

    while (!stopping)
	sleep(10000);

    daemon_cleanup();
}

jint com::redhat::tomcat::Daemon::getLogSerial()
{
    return logserial;
}
